## drmips 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(DrMIPS NONE)

# Configurations
set(DRMIPS_SHARE_DIR "share/drmips")
set(DRMIPS_DOC_DIR "share/doc/drmips")
set(DRMIPS_MANUALS_DIR "${DRMIPS_DOC_DIR}/manuals")
set(DRMIPS_MANUALS_DIR_ABSOLUTE "${CMAKE_INSTALL_PREFIX}/${DRMIPS_MANUALS_DIR}")
set(DRMIPS_JAVADOC_DIR "${DRMIPS_DOC_DIR}/javadoc")
set(DRMIPS_DIST_BUILD_DIR "${CMAKE_BINARY_DIR}/dist")
set(DRMIPS_ZIP_BUILD_DIR "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}")
option(DRMIPS_BUILD_MANUALS "Build and install the manuals?" ON)
option(DRMIPS_BUILD_PC_VERSION "Build and install the PC version of the simulator?" ON)
option(DRMIPS_BUILD_ANDROID_VERSION "Build and install the Android version of the simulator?" OFF)
option(DRMIPS_BUILD_SIMULATOR_JAVADOC "Build and install the Java API documentation of the simulation logic?" OFF)
# force javac to use UTF-8 encoding and set JDK/JRE 6 as the target
set(CMAKE_JAVA_COMPILE_FLAGS "-encoding" "UTF-8" "-source" "1.6" "-target" "1.6")

# Include required CMake modules and programs
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
if(${DRMIPS_BUILD_PC_VERSION} OR ${DRMIPS_BUILD_ANDROID_VERSION} OR ${DRMIPS_BUILD_SIMULATOR_JAVADOC})
	find_package(Java REQUIRED)
	include(UseJava)
endif()

if(${DRMIPS_BUILD_ANDROID_VERSION})
	find_package(Android REQUIRED)
endif()

if(${DRMIPS_BUILD_MANUALS})
	include(UseLATEX)
	
	# Mark several LaTeX options as advanced
	mark_as_advanced(FORCE BIBTEX_COMPILER
	                       DVIPS_CONVERTER
	                       HTLATEX_CONVERTER
	                       IMAGEMAGICK_CONVERT
	                       LATEX2HTML_CONVERTER
	                       LATEX_COMPILER
	                       MAKEINDEX_COMPILER
	                       PDFLATEX_COMPILER
	                       PDFTOPS_CONVERTER
	                       PS2PDF_CONVERTER
	                       XINDY_COMPILER
	                       LATEX_OUTPUT_PATH)
endif()

# Subdirectories
if(${DRMIPS_BUILD_PC_VERSION} OR ${DRMIPS_BUILD_ANDROID_VERSION} OR ${DRMIPS_BUILD_SIMULATOR_JAVADOC})
	add_subdirectory(src/simulator/DrMIPSSimulator)
endif()
if(${DRMIPS_BUILD_PC_VERSION})
	add_subdirectory(src/pc/DrMIPS)
endif()
if(${DRMIPS_BUILD_ANDROID_VERSION})
	add_subdirectory(src/android/DrMIPS)
endif()
if(${DRMIPS_BUILD_MANUALS})
	add_subdirectory(doc/manuals)
endif()

# Uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake)

# Distribution target
if(${DRMIPS_BUILD_PC_VERSION} AND ${DRMIPS_BUILD_MANUALS})
	add_custom_command(OUTPUT "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.zip"
	                   COMMAND "${Java_JAR_EXECUTABLE}" cfM "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.zip"
	                           "-C" "${DRMIPS_DIST_BUILD_DIR}" "${PROJECT_NAME}"
	                   DEPENDS pc_version manuals COMMENT "Creating ZIP file for distribution of the PC version")
	add_custom_target(dist DEPENDS "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.zip")
endif()

# Mark first CMake run as finished
set(DONE_FIRST_RUN ON CACHE INTERNAL "Has CMake been executed at least once already?")

=== manuals/CMakeLists.txt ===
# Configurations
if(NOT DONE_FIRST_RUN)
	# Allow in-source builds
	set(LATEX_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/build" CACHE STRING
	                      "Specifies the location to place LaTeX output." FORCE)
	# Reduce output of latex/pdflatex by default
	set(PDFLATEX_COMPILER_FLAGS "-interaction=batchmode" CACHE STRING
	                            "Flags passed to pdflatex." FORCE)
	set(LATEX_COMPILER_FLAGS "-interaction=batchmode" CACHE STRING
	                         "Flags passed to latex." FORCE)
endif()

# TeX files (without the extension)
set(SRC configuration-en configuração-pt_PT manual-en manual-pt_PT)

# Other resource files
file(GLOB RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "listings/*")

# Build and install targets
add_custom_target(manuals) # add meta-target "manuals"
foreach(TEX ${SRC})
	add_latex_document("${TEX}.tex" INPUTS ${RES} DEFAULT_PDF MANGLE_TARGET_NAMES) # build target
	add_dependencies(manuals "${TEX}_pdf") # add this document to "manuals" meta-target
	install(FILES "${LATEX_OUTPUT_PATH}/${TEX}.pdf" DESTINATION "${DRMIPS_MANUALS_DIR}") # install target
	add_custom_command(TARGET "${TEX}_pdf" POST_BUILD
	                   COMMAND ${CMAKE_COMMAND} -E copy_if_different
	                           "${LATEX_OUTPUT_PATH}/${TEX}.pdf" "${DRMIPS_ZIP_BUILD_DIR}/doc/${TEX}.pdf"
	                   COMMENT "Copying ${TEX}.pdf to the ZIP build directory"
	                   VERBATIM) # copy PDF to DRMIPS_ZIP_BUILD_DIRECTORY/doc
endforeach()

=== android/DrMIPS/CMakeLists.txt ===
# To generate a (different) keyfor signing:
# $ keytool -genkey -v -keystore my-release-key.keystore -alias alias_name\
#   -keyalg RSA -keysize 2048 -validity 10000

# Configurations
option(DRMIPS_ANDROID_RELEASE_MODE "If ON, the Android version will be built in Release mode (signed), else it will be in Debug mode." OFF)
set(DRMIPS_ANDROID_KEYSTORE_PATH "" CACHE FILEPATH "Path to the keystore used to sign the Android apk file (in Release mode).")
set(DRMIPS_ANDROID_KEYSTORE_ALIAS "" CACHE STRING "Alias of the keystore entry used to sign the Android apk file (in Release mode).")
set(ANDROID_BUILD_XML_PATH "${CMAKE_CURRENT_SOURCE_DIR}/build.xml")
set(ANDROID_LOCAL_PROPERTIES_PATH "${CMAKE_CURRENT_SOURCE_DIR}/local.properties")
set(ANDROID_BUILD_DIR "${CMAKE_CURRENT_SOURCE_DIR}/bin")
set(ANDROID_DEBUG_APK_PATH "${ANDROID_BUILD_DIR}/${PROJECT_NAME}-debug.apk")
set(ANDROID_UNSIGNED_APK_PATH "${ANDROID_BUILD_DIR}/${PROJECT_NAME}-release-unsigned.apk")
set(ANDROID_RELEASE_APK_PATH "${ANDROID_BUILD_DIR}/${PROJECT_NAME}.apk")

# Command to update/create build.xml and local.properties
add_custom_command(OUTPUT "${ANDROID_BUILD_XML_PATH}" "${ANDROID_LOCAL_PROPERTIES_PATH}"
                   COMMAND "${ANDROID_TOOL}" update project "-n" "${PROJECT_NAME}"
                           "-p" "${CMAKE_CURRENT_SOURCE_DIR}"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                   DEPENDS "${PROJECT_NAME}Simulator"
                   COMMENT "Updating build.xml and local.properties"
                   VERBATIM)

# Target to build the project in Debug mode
add_custom_target(android_debug
                  COMMAND "${ANT_TOOL}" ${ANT_TOOL_FLAGS} debug
                  COMMAND "${CMAKE_COMMAND}" "-E" rename "${ANDROID_RELEASE_APK_PATH}"
                          "${ANDROID_DEBUG_APK_PATH}"
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  DEPENDS "${ANDROID_BUILD_XML_PATH}" "${ANDROID_LOCAL_PROPERTIES_PATH}"
                  COMMENT "Building Android project (Debug)"
                  VERBATIM)

# Target to build the project in Release mode
add_custom_target(android_release
                  COMMAND "${ANT_TOOL}" ${ANT_TOOL_FLAGS} release
                  COMMAND "${JARSIGNER_TOOL}" ${JARSIGNER_TOOL_FLAGS}
                          "-keystore" "${DRMIPS_ANDROID_KEYSTORE_PATH}"
                          "${ANDROID_UNSIGNED_APK_PATH}" "${DRMIPS_ANDROID_KEYSTORE_ALIAS}"
                  COMMAND "${ZIPALIGN_TOOL}" ${ZIPALIGN_TOOL_FLAGS} "${ANDROID_UNSIGNED_APK_PATH}"
                          "${ANDROID_RELEASE_APK_PATH}"
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  DEPENDS "${ANDROID_BUILD_XML_PATH}" "${ANDROID_LOCAL_PROPERTIES_PATH}"
                  COMMENT "Building Android project (Release)"
                  VERBATIM)

# Android build target
if(DRMIPS_ANDROID_RELEASE_MODE) # release mode
	if(DRMIPS_ANDROID_KEYSTORE_PATH AND DRMIPS_ANDROID_KEYSTORE_ALIAS)
		add_custom_target(android_version ALL DEPENDS android_release)
		
		# Copy apk to DRMIPS_DIST_BUILD_DIRECTORY
		add_custom_command(TARGET android_version POST_BUILD
		                   COMMAND "${CMAKE_COMMAND}" -E copy_if_different
		                           "${ANDROID_RELEASE_APK_PATH}" "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.apk"
		                   COMMENT "Copying ${PROJECT_NAME}.apk to the dist directory"
		                   VERBATIM)
	else()
		message(SEND_ERROR "DRMIPS_ANDROID_KEYSTORE_PATH and DRMIPS_ANDROID_KEYSTORE_ALIAS variables must be set to build the Android project in Release mode.")
	endif()
else() # debug mode
	add_custom_target(android_version ALL DEPENDS android_debug)
endif()

# Add "bin" and "gen" directories to the "clean" target
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                         "${CMAKE_CURRENT_SOURCE_DIR}/bin;${CMAKE_CURRENT_SOURCE_DIR}/gen")

=== simulator/DrMIPSSimulator/CMakeLists.txt ===
# Subdirectory
add_subdirectory(src)

# Configurations
set(PC_CPU_PATH "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/cpu")
set(ANDROID_CPU_PATH "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/res/raw")

# Copy .cpu and .set files to the PC and Android projects
message(STATUS "Copying cpu/ to the PC and Android projects")
file(MAKE_DIRECTORY "${PC_CPU_PATH}")
file(MAKE_DIRECTORY "${ANDROID_CPU_PATH}")
file(GLOB FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/cpu" "cpu/*")
foreach(RES ${FILES})
	configure_file("cpu/${RES}" "${PC_CPU_PATH}/${RES}" COPYONLY)
	
	string(REGEX REPLACE "[\\.\\-]" "_" DST "${RES}") # replace '.' and '-' in the name with '_'
	configure_file("cpu/${RES}" "${ANDROID_CPU_PATH}/${DST}" COPYONLY)
endforeach()
message(STATUS "Copying cpu/ to the PC and Android projects -- done")

=== simulator/DrMIPSSimulator/src/CMakeLists.txt ===
# Directory where Java classes are compiled to (should not be changed)
set(CLASS_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${PROJECT_NAME}.dir")

# List of Java source files
file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "org/*.java")

# Jar compilation target
add_jar("${PROJECT_NAME}Simulator" ${SRC})
add_custom_target(simulator DEPENDS "${PROJECT_NAME}Simulator") # add meta-target "simulator"

# Javadoc target
if(DRMIPS_BUILD_SIMULATOR_JAVADOC)
	create_javadoc(${PROJECT_NAME} FILES ${SRC}
	                               WINDOWTITLE "${PROJECT_NAME}" DOCTITLE "${PROJECT_NAME}"
	                               INSTALLPATH "${DRMIPS_JAVADOC_DIR}")
	add_custom_target(simulator_javadoc DEPENDS "${PROJECT_NAME}_javadoc") # add meta-target "simulator_javadoc"
endif()

# Copy jar to the lib/ directory of the PC version project
add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -E copy_if_different
                           "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
                           "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/lib/${PROJECT_NAME}Simulator.jar"
                   COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the PC version project lib/ directory"
                   VERBATIM)

# Copy jar to the libs/ directory of the Android version project
add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -E copy_if_different
                           "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
                           "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/libs/${PROJECT_NAME}Simulator.jar"
                   COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the Android version project libs/ directory"
                   VERBATIM)

# Copy jar to DRMIPS_ZIP_BUILD_DIRECTORY
add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -E copy_if_different
                           "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
                           "${DRMIPS_ZIP_BUILD_DIR}/lib/${PROJECT_NAME}Simulator.jar"
                   COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the ZIP build directory"
                   VERBATIM)

# Add copied DrMIPSSimulator.jar files to the "clean" target
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                         "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/lib/${PROJECT_NAME}Simulator.jar;${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/libs/${PROJECT_NAME}Simulator.jar")

=== debian/changelog ===
drmips (1.2.3-1) unstable; urgency=low

  * Initial release. (Closes: #751397)

 -- Bruno Nova <brunomb.nova@gmail.com>  Sat, 27 Sep 2014 12:24:17 +0100

=== debian/control ===
Source: drmips
Section: java
Priority: optional
Maintainer: Bruno Nova <brunomb.nova@gmail.com>
Build-Depends: debhelper (>= 9), cmake (>= 2.8), texlive, texlive-latex-extra,
               texlive-science, texlive-lang-portuguese,
               openjdk-7-jdk | java7-jdk | openjdk-6-jdk | java6-jdk
Standards-Version: 3.9.5
Homepage: https://bitbucket.org/brunonova/drmips
Vcs-Git: https://bitbucket.org/brunonova/drmips -b debian
Vcs-Browser: https://bitbucket.org/brunonova/drmips/src/debian

Package: drmips
Architecture: all
Depends: ${misc:Depends}, openjdk-7-jre | java7-runtime | openjdk-6-jre | java6-runtime
Description: Educational MIPS simulator
 DrMIPS is a graphical simulator of the MIPS processor to support computer
 architecture teaching and learning. It is intuitive, versatile and
 configurable.
 .
 The simulator is available not only for personal computers but also for
 Android devices, especially tablets.
 .
 DrMIPS was created under the Master's dissertation entitled 
 'Tool to Support Computer Architecture Teaching and Learning' at the
 Faculty of Engineering of the University of Porto, in Portugal.
 .
 This package installs the PC version of the simulator.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

# Override to remove files that are not cleaned by "dh_clean"
override_dh_clean:
	dh_clean
	rm -rf src/android/DrMIPS/res/raw src/pc/DrMIPS/cpu/ \
	   src/android/DrMIPS/libs/DrMIPSSimulator.jar src/pc/DrMIPS/lib/DrMIPSSimulator.jar \
	   src/pc/DrMIPS/src/org/feup/brunonova/drmips/gui/DrMIPS.java

## drmips 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 project(DrMIPS NONE)
 
 # Configurations
-set(DRMIPS_SHARE_DIR "share/drmips")
-set(DRMIPS_DOC_DIR "share/doc/drmips")
+set(DRMIPS_SHARE_DIR "share/drmips" CACHE STRING "Where to install program data and resources (relative to CMAKE_INSTALL_PREFIX)")
+set(DRMIPS_DOC_DIR "share/doc/drmips" CACHE STRING "Where to install the documentation (relative to CMAKE_INSTALL_PREFIX)")
 set(DRMIPS_MANUALS_DIR "${DRMIPS_DOC_DIR}/manuals")
 set(DRMIPS_MANUALS_DIR_ABSOLUTE "${CMAKE_INSTALL_PREFIX}/${DRMIPS_MANUALS_DIR}")
 set(DRMIPS_JAVADOC_DIR "${DRMIPS_DOC_DIR}/javadoc")

=== manuals/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 endif()
 
 # TeX files (without the extension)
-set(SRC configuration-en configuração-pt_PT manual-en manual-pt_PT)
+set(SRC configuration-en configuracao-pt manual-en manual-pt)
 
 # Other resource files
 file(GLOB RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "listings/*")

=== android/DrMIPS/CMakeLists.txt ===
# To generate a (different) keyfor signing:
# $ keytool -genkey -v -keystore my-release-key.keystore -alias alias_name\
#   -keyalg RSA -keysize 2048 -validity 10000

# Configurations
option(DRMIPS_ANDROID_RELEASE_MODE "If ON, the Android version will be built in Release mode (signed), else it will be in Debug mode." OFF)
set(DRMIPS_ANDROID_KEYSTORE_PATH "" CACHE FILEPATH "Path to the keystore used to sign the Android apk file (in Release mode).")
set(DRMIPS_ANDROID_KEYSTORE_ALIAS "" CACHE STRING "Alias of the keystore entry used to sign the Android apk file (in Release mode).")
set(ANDROID_BUILD_DIR "${CMAKE_CURRENT_SOURCE_DIR}/app/build/outputs/apk")
set(ANDROID_DEBUG_APK_PATH "${ANDROID_BUILD_DIR}/app-debug.apk")
set(ANDROID_UNSIGNED_APK_PATH "${ANDROID_BUILD_DIR}/app-release-unsigned.apk")
set(ANDROID_RELEASE_APK_PATH "${ANDROID_BUILD_DIR}/${PROJECT_NAME}.apk")

# Find Gradle script
if(${UNIX})
	set(ANDROID_GRADLEW "${CMAKE_CURRENT_SOURCE_DIR}/gradlew")
else()
	set(ANDROID_GRADLEW "${CMAKE_CURRENT_SOURCE_DIR}/gradlew.bat")
endif()
set(ANDROID_GRADLEW_FLAGS "")

# Target to build the project in Debug mode
add_custom_target(android_debug
                  COMMAND "${ANDROID_GRADLEW}" ${ANDROID_GRADLEW_FLAGS} assembleDebug
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  DEPENDS "${PROJECT_NAME}Simulator"
                  COMMENT "Building Android project (Debug)"
                  VERBATIM)

# Target to build the project in Release mode
add_custom_target(android_release
                  COMMAND "${ANDROID_GRADLEW}" ${ANDROID_GRADLEW_FLAGS} assembleRelease
                  COMMAND "${JARSIGNER_TOOL}" ${JARSIGNER_TOOL_FLAGS}
                          "-keystore" "${DRMIPS_ANDROID_KEYSTORE_PATH}"
                          "${ANDROID_UNSIGNED_APK_PATH}" "${DRMIPS_ANDROID_KEYSTORE_ALIAS}"
                  COMMAND "${ZIPALIGN_TOOL}" ${ZIPALIGN_TOOL_FLAGS} "${ANDROID_UNSIGNED_APK_PATH}"
                          "${ANDROID_RELEASE_APK_PATH}"
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  DEPENDS "${PROJECT_NAME}Simulator"
                  COMMENT "Building Android project (Release)"
                  VERBATIM)

# Android build target
if(DRMIPS_ANDROID_RELEASE_MODE) # release mode
	if(DRMIPS_ANDROID_KEYSTORE_PATH AND DRMIPS_ANDROID_KEYSTORE_ALIAS)
		add_custom_target(android_version ALL DEPENDS android_release)
		
		# Copy apk to DRMIPS_DIST_BUILD_DIRECTORY
		add_custom_command(TARGET android_version POST_BUILD
		                   COMMAND "${CMAKE_COMMAND}" -E copy_if_different
		                           "${ANDROID_RELEASE_APK_PATH}" "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.apk"
		                   COMMENT "Copying ${PROJECT_NAME}.apk to the dist directory"
		                   VERBATIM)
	else()
		message(SEND_ERROR "DRMIPS_ANDROID_KEYSTORE_PATH and DRMIPS_ANDROID_KEYSTORE_ALIAS variables must be set to build the Android project in Release mode.")
	endif()
else() # debug mode
	add_custom_target(android_version ALL DEPENDS android_debug)
endif()

# Add "build" and "app/build" directories to the "clean" target
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                         "${CMAKE_CURRENT_SOURCE_DIR}/build;${CMAKE_CURRENT_SOURCE_DIR}/app/build")

=== simulator/DrMIPSSimulator/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Configurations
 set(PC_CPU_PATH "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/cpu")
-set(ANDROID_CPU_PATH "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/res/raw")
+set(ANDROID_CPU_PATH "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/app/src/main/res/raw")
 
 # Copy .cpu and .set files to the PC and Android projects
 message(STATUS "Copying cpu/ to the PC and Android projects")

=== pc/DrMIPS/src/CMakeLists.txt ===
# Directory where Java classes are compiled to (should not be changed)
set(CLASS_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${PROJECT_NAME}.dir")

# The manifest file (specifying the Main class and the libraries)
set(MANIFEST "${CMAKE_CURRENT_BINARY_DIR}/Manifest.mf")

# Configure files
configure_file("org/feup/brunonova/drmips/gui/DrMIPS.java.in"
               "${CMAKE_CURRENT_SOURCE_DIR}/org/feup/brunonova/drmips/gui/DrMIPS.java")

# List of Java source files
file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "org/*.java" "com/jtattoo/plaf/*"
                               "org/fife/io/*" "org/fife/print/*" "org/fife/ui/*" "org/fife/util/*")

# List of resource files
file(GLOB_RECURSE RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "res/*" "org/*.properties")

# List of libraries (without the path)
set(LIBS DrMIPSSimulator.jar)

# Generate list of paths to the libraries for add_jar(), class-Path for Manifest.mf and class-Path for javadoc
set(LIBS_PATHS)
set(CLASS_PATH "Class-Path:")
set(CLASS_PATH_JAVADOC "")
foreach(LIB ${LIBS})
	list(APPEND LIBS_PATHS "../lib/${LIB}")
	set(CLASS_PATH "${CLASS_PATH} lib/${LIB}")
	if(CLASS_PATH_JAVADOC)
		set(CLASS_PATH_JAVADOC "${CLASS_PATH_JAVADOC}:")
	endif()
	set(CLASS_PATH_JAVADOC "${CLASS_PATH_JAVADOC}../lib/${LIB}")
endforeach()

# Generate Manifest file with the Class-Path
message(STATUS "PC version: generating Manifest.mf")
file(WRITE "${MANIFEST}" "${CLASS_PATH}\n")
message(STATUS "PC version: generating Manifest.mf -- done")

# Jar compilation target
add_jar(${PROJECT_NAME} ${SRC} ${RES} INCLUDE_JARS ${LIBS_PATHS} MANIFEST ${MANIFEST}
                        ENTRY_POINT org.feup.brunonova.drmips.gui.DrMIPS)
add_custom_target(pc_version DEPENDS ${PROJECT_NAME}) # add meta-target "pc_version"
add_dependencies(${PROJECT_NAME} "${PROJECT_NAME}Simulator") # depend on the simulator project

# Install target
install_jar(${PROJECT_NAME} "${DRMIPS_SHARE_DIR}")

# Copy jar to DRMIPS_ZIP_BUILD_DIRECTORY
add_custom_command(TARGET "${PROJECT_NAME}" POST_BUILD
                  COMMAND ${CMAKE_COMMAND} -E copy_if_different
                          "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.jar" "${DRMIPS_ZIP_BUILD_DIR}/${PROJECT_NAME}.jar"
                  COMMENT "Copying ${PROJECT_NAME}.jar to the ZIP build directory"
                  VERBATIM)

=== simulator/DrMIPSSimulator/src/CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different
                            "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
-                           "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/libs/${PROJECT_NAME}Simulator.jar"
+                           "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/app/libs/${PROJECT_NAME}Simulator.jar"
                    COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the Android version project libs/ directory"
                    VERBATIM)

=== debian/changelog ===
drmips (1.3.0-2~ubuntu14.04.1) trusty-backports; urgency=medium

  * No-change backport to trusty (LP: #1458035)

 -- Micah Gersten <micahg@ubuntu.com>  Tue, 09 Jun 2015 14:16:22 -0500

drmips (1.3.0-2) unstable; urgency=low

  * Upload to unstable.

 -- Bruno Nova <brunomb.nova@gmail.com>  Wed, 06 May 2015 20:54:32 +0100

drmips (1.3.0-1) experimental; urgency=low

  * New upstream release.
  * debian/control:
    - Bumped Standards-Version to 3.9.6.
    - Changed section to electronics.
    - Simplified Build-Depends by removing redundant dependencies on java7-jdk
      and openjdk-6-jdk.
    - Simplified Depends by removing redundant dependencies on java7-runtime
      and openjdk-6-jre.
  * debian/copyright:
    - Added commercial license of src/pc/DrMIPS/src/com/jtattoo/*.
    - Added copyright and license of src/pc/DrMIPS/src/org/jscroll/*.
    - Updated copyright years.
  * debian/doc-base.*: files renamed (by upstream).
  * debian/lintian-overrides: removed as it's no longer necessary.
  * debian/rules: updated the paths that dh_clean removes.
  * debian/source/lintian-overrides:
    - Removed an override that is no longer necessary.
    - Added an override for source-contains-prebuilt-java-object in the path
      src/android/DrMIPS/gradle/wrapper/gradle-wrapper.jar.
  * debian/upstream/signing-key.asc: updated the upstream signing key.

 -- Bruno Nova <brunomb.nova@gmail.com>  Mon, 23 Mar 2015 14:23:01 +0000

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: drmips
-Section: java
+Section: electronics
 Priority: optional
 Maintainer: Bruno Nova <brunomb.nova@gmail.com>
 Build-Depends: debhelper (>= 9), cmake (>= 2.8), texlive, texlive-latex-extra,
                texlive-science, texlive-lang-portuguese,
-               openjdk-7-jdk | java7-jdk | openjdk-6-jdk | java6-jdk
-Standards-Version: 3.9.5
+               openjdk-7-jdk | java6-jdk
+Standards-Version: 3.9.6
 Homepage: https://bitbucket.org/brunonova/drmips
 Vcs-Git: https://bitbucket.org/brunonova/drmips -b debian
 Vcs-Browser: https://bitbucket.org/brunonova/drmips/src/debian
 
 Package: drmips
 Architecture: all
-Depends: ${misc:Depends}, openjdk-7-jre | java7-runtime | openjdk-6-jre | java6-runtime
+Depends: ${misc:Depends}, openjdk-7-jre | java6-runtime
 Description: Educational MIPS simulator
  DrMIPS is a graphical simulator of the MIPS processor to support computer
  architecture teaching and learning. It is intuitive, versatile and

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

# Override to remove files that are not cleaned by "dh_clean"
override_dh_clean:
	dh_clean
	rm -rf src/pc/DrMIPS/cpu/ src/android/DrMIPS/app/src/main/res/raw/ \
	   src/android/DrMIPS/app/libs/DrMIPSSimulator.jar src/pc/DrMIPS/lib/DrMIPSSimulator.jar \
	   src/pc/DrMIPS/src/org/feup/brunonova/drmips/gui/DrMIPS.java

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://bitbucket.org/brunonova/drmips/downloads /brunonova/drmips/downloads/DrMIPS_v(.*)\.tar.(?:gz|bz2|xz)

## drmips 1.3.2

=== pc/DrMIPS/src/CMakeLists.txt ===
--- 
+++ 
@@ -10,10 +10,12 @@
 
 # List of Java source files
 file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "org/*.java" "com/jtattoo/plaf/*"
-                               "org/fife/io/*" "org/fife/print/*" "org/fife/ui/*" "org/fife/util/*")
+                               "org/fife/io/*" "org/fife/print/*" "org/fife/ui/*"
+                               "org/fife/util/*" "joptsimple/*.java")
 
 # List of resource files
-file(GLOB_RECURSE RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "res/*" "org/*.properties")
+file(GLOB_RECURSE RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "res/*"
+                               "org/*.properties" "joptsimple/*.properties")
 
 # List of libraries (without the path)
 set(LIBS DrMIPSSimulator.jar)

=== simulator/DrMIPSSimulator/src/CMakeLists.txt ===
--- 
+++ 
@@ -42,4 +42,4 @@
 
 # Add copied DrMIPSSimulator.jar files to the "clean" target
 set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
-                         "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/lib/${PROJECT_NAME}Simulator.jar;${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/libs/${PROJECT_NAME}Simulator.jar") 
+                         "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/lib/${PROJECT_NAME}Simulator.jar;${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/app/libs/${PROJECT_NAME}Simulator.jar")

=== debian/changelog ===
drmips (1.3.2-1~bpo8+1) jessie-backports; urgency=low

  * Rebuild for jessie-backports.

 -- Bruno Nova <brunomb.nova@gmail.com>  Wed, 07 Oct 2015 20:14:27 +0100

drmips (1.3.2-1) unstable; urgency=low

  * New upstream release.
  * debian/control: updated Homepage and Vcs-* fields.
  * debian/copyright: updated Source field.
  * debian/docs: added to install AUTHORS, NEWS and README.md.
  * debian/watch: updated the URL.

 -- Bruno Nova <brunomb.nova@gmail.com>  Mon, 21 Sep 2015 19:56:47 +0100

drmips (1.3.1-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: added license of src/pc/DrMIPS/src/joptsimple/*.

 -- Bruno Nova <brunomb.nova@gmail.com>  Thu, 03 Sep 2015 19:55:21 +0100

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
                texlive-science, texlive-lang-portuguese,
                openjdk-7-jdk | java6-jdk
 Standards-Version: 3.9.6
-Homepage: https://bitbucket.org/brunonova/drmips
-Vcs-Git: https://bitbucket.org/brunonova/drmips -b debian
-Vcs-Browser: https://bitbucket.org/brunonova/drmips/src/debian
+Homepage: http://brunonova.github.io/drmips/
+Vcs-Git: https://github.com/brunonova/drmips -b debian
+Vcs-Browser: https://github.com/brunonova/drmips/tree/debian
 
 Package: drmips
 Architecture: all

## drmips 2.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(DrMIPS NONE)

# Configurations
set(DRMIPS_SHARE_DIR share/drmips CACHE STRING "Where to install program data and resources (relative to CMAKE_INSTALL_PREFIX)")
set(DRMIPS_DOC_DIR share/doc/drmips CACHE STRING "Where to install the documentation (relative to CMAKE_INSTALL_PREFIX)")
set(DRMIPS_MANUALS_DIR "${DRMIPS_DOC_DIR}/manuals")
set(DRMIPS_MANUALS_DIR_ABSOLUTE "${CMAKE_INSTALL_PREFIX}/${DRMIPS_MANUALS_DIR}")
set(DRMIPS_JAVADOC_DIR "${DRMIPS_DOC_DIR}/javadoc")
set(DRMIPS_DIST_BUILD_DIR "${CMAKE_BINARY_DIR}/dist")
set(DRMIPS_ZIP_BUILD_DIR "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}")
option(DRMIPS_BUILD_PC_VERSION "Build and install the PC version of the simulator?" ON)
option(DRMIPS_BUILD_ANDROID_VERSION "Build and install the Android version of the simulator?" OFF)
option(DRMIPS_BUILD_SIMULATOR_JAVADOC "Build and install the Java API documentation of the simulation logic?" OFF)
if(DRMIPS_BUILD_PC_VERSION OR DRMIPS_BUILD_ANDROID_VERSION OR DRMIPS_BUILD_SIMULATOR_JAVADOC)
	set(DRMIPS_BUILD_SIMULATOR ON)
else()
	set(DRMIPS_BUILD_SIMULATOR OFF)
endif()
# force javac to use UTF-8 encoding and set JDK/JRE 7 as the target
set(CMAKE_JAVA_COMPILE_FLAGS -encoding UTF-8 -source 1.7 -target 1.7)

# Include required CMake modules and programs
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
if(DRMIPS_BUILD_SIMULATOR)
	# Find Java
	find_package(Java REQUIRED)
	include(UseJava)

	# Find JUnit
	find_file(JUNIT_PATH NAMES junit4.jar PATHS "${JAVA_LIB_INSTALL_DIR}" /usr/share/java
		                 DOC "Path to the JUnit library.")
	mark_as_advanced(JUNIT_PATH)
	if(JUNIT_PATH)
		option(DRMIPS_BUILD_TESTS "Build the unit tests of the simulator and enable testing?" ON)
		message(STATUS "Found JUnit: ${JUNIT_PATH}")
	else()
		message(WARNING "JUnit not found.")
	endif()
endif()

if(DRMIPS_BUILD_ANDROID_VERSION)
	# Find Android tools
	find_package(Android REQUIRED)
endif()

# Subdirectories
add_subdirectory(doc/manuals)
if(DRMIPS_BUILD_SIMULATOR)
	add_subdirectory(src/simulator/DrMIPSSimulator)
endif()
if(DRMIPS_BUILD_PC_VERSION)
	add_subdirectory(src/pc/DrMIPS)
endif()
if(DRMIPS_BUILD_ANDROID_VERSION)
	add_subdirectory(src/android/DrMIPS)
endif()

# Uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake")

# Distribution target
if(DRMIPS_BUILD_PC_VERSION)
	add_custom_command(OUTPUT "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.zip"
	                   COMMAND "${Java_JAR_EXECUTABLE}" cfM "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.zip"
	                           -C "${DRMIPS_DIST_BUILD_DIR}" "${PROJECT_NAME}"
	                   DEPENDS pc_version COMMENT "Creating ZIP file for distribution of the PC version")
	add_custom_target(dist DEPENDS "${DRMIPS_DIST_BUILD_DIR}/${PROJECT_NAME}.zip")
endif()

=== manuals/CMakeLists.txt ===
# Install target
install(FILES index.html style.css DESTINATION "${DRMIPS_MANUALS_DIR}")
install(DIRECTORY img en pt DESTINATION "${DRMIPS_MANUALS_DIR}")

# Copy documentation files to DRMIPS_ZIP_BUILD_DIR/doc
message(STATUS "Copying documentation files to the ZIP build directory")
file(MAKE_DIRECTORY "${DRMIPS_ZIP_BUILD_DIR}/doc")
file(COPY index.html style.css img en pt DESTINATION "${DRMIPS_ZIP_BUILD_DIR}/doc")
message(STATUS "Copying documentation files to the ZIP build directory -- done")

=== android/DrMIPS/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 add_custom_target(android_release
                   COMMAND "${ANDROID_GRADLEW}" ${ANDROID_GRADLEW_FLAGS} assembleRelease
                   COMMAND "${JARSIGNER_TOOL}" ${JARSIGNER_TOOL_FLAGS}
-                          "-keystore" "${DRMIPS_ANDROID_KEYSTORE_PATH}"
+                          -keystore "${DRMIPS_ANDROID_KEYSTORE_PATH}"
                           "${ANDROID_UNSIGNED_APK_PATH}" "${DRMIPS_ANDROID_KEYSTORE_ALIAS}"
                   COMMAND "${ZIPALIGN_TOOL}" ${ZIPALIGN_TOOL_FLAGS} "${ANDROID_UNSIGNED_APK_PATH}"
                           "${ANDROID_RELEASE_APK_PATH}"

=== pc/DrMIPS/CMakeLists.txt ===
# Subdirectory
add_subdirectory(src)

# Configurations
set(DRMIPS_JAR_PATH "${CMAKE_INSTALL_PREFIX}/${DRMIPS_SHARE_DIR}/${PROJECT_NAME}.jar")
configure_file(drmips.in drmips)

# Copy distributable static files to DRMIPS_ZIP_BUILD_DIR
message(STATUS "PC version: copying cpu,lang,lib to the ZIP build directory")
file(COPY cpu lang DESTINATION "${DRMIPS_ZIP_BUILD_DIR}")
message(STATUS "PC version: copying cpu,lang,lib to the ZIP build directory -- done")

# Install target
install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/drmips" DESTINATION bin)
install(DIRECTORY cpu lang lib DESTINATION "${DRMIPS_SHARE_DIR}")

=== simulator/DrMIPSSimulator/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
 # Subdirectory
 add_subdirectory(src)
+if(DRMIPS_BUILD_TESTS)
+	add_subdirectory(test)
+endif()
 
 # Configurations
 set(PC_CPU_PATH "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/cpu")
@@ -9,7 +12,7 @@
 message(STATUS "Copying cpu/ to the PC and Android projects")
 file(MAKE_DIRECTORY "${PC_CPU_PATH}")
 file(MAKE_DIRECTORY "${ANDROID_CPU_PATH}")
-file(GLOB FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/cpu" "cpu/*")
+file(GLOB FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/cpu" cpu/*)
 foreach(RES ${FILES})
 	configure_file("cpu/${RES}" "${PC_CPU_PATH}/${RES}" COPYONLY)

=== pc/DrMIPS/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,21 +1,19 @@
-# Directory where Java classes are compiled to (should not be changed)
-set(CLASS_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${PROJECT_NAME}.dir")
-
 # The manifest file (specifying the Main class and the libraries)
 set(MANIFEST "${CMAKE_CURRENT_BINARY_DIR}/Manifest.mf")
 
 # Configure files
-configure_file("org/feup/brunonova/drmips/gui/DrMIPS.java.in"
-               "${CMAKE_CURRENT_SOURCE_DIR}/org/feup/brunonova/drmips/gui/DrMIPS.java")
+configure_file(brunonova/drmips/pc/DrMIPS.java.in
+               "${CMAKE_CURRENT_SOURCE_DIR}/brunonova/drmips/pc/DrMIPS.java")
 
 # List of Java source files
-file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "org/*.java" "com/jtattoo/plaf/*"
-                               "org/fife/io/*" "org/fife/print/*" "org/fife/ui/*"
-                               "org/fife/util/*" "joptsimple/*.java")
+file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" brunonova/*.java
+                               org/*.java com/jtattoo/plaf/*
+                               org/fife/io/* org/fife/print/* org/fife/ui/*
+                               org/fife/util/* joptsimple/*.java)
 
 # List of resource files
-file(GLOB_RECURSE RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "res/*"
-                               "org/*.properties" "joptsimple/*.properties")
+file(GLOB_RECURSE RES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" res/*
+                               org/*.properties joptsimple/*.properties)
 
 # List of libraries (without the path)
 set(LIBS DrMIPSSimulator.jar)
@@ -40,7 +38,7 @@
 
 # Jar compilation target
 add_jar(${PROJECT_NAME} ${SRC} ${RES} INCLUDE_JARS ${LIBS_PATHS} MANIFEST ${MANIFEST}
-                        ENTRY_POINT org.feup.brunonova.drmips.gui.DrMIPS)
+                        ENTRY_POINT brunonova.drmips.pc.DrMIPS)
 add_custom_target(pc_version DEPENDS ${PROJECT_NAME}) # add meta-target "pc_version"
 add_dependencies(${PROJECT_NAME} "${PROJECT_NAME}Simulator") # depend on the simulator project

=== simulator/DrMIPSSimulator/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,11 @@
-# Directory where Java classes are compiled to (should not be changed)
-set(CLASS_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${PROJECT_NAME}.dir")
-
 # List of Java source files
-file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "org/*.java")
+file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" brunonova/*.java org/*.java)
 
 # Jar compilation target
 add_jar("${PROJECT_NAME}Simulator" ${SRC})
 add_custom_target(simulator DEPENDS "${PROJECT_NAME}Simulator") # add meta-target "simulator"
+get_property(SIMULATOR_JAR_PATH TARGET "${PROJECT_NAME}Simulator" PROPERTY JAR_FILE) # find path to built jar
+set(SIMULATOR_JAR_PATH "${SIMULATOR_JAR_PATH}" PARENT_SCOPE) # make variable available in parent scope
 
 # Javadoc target
 if(DRMIPS_BUILD_SIMULATOR_JAVADOC)
@@ -19,7 +18,7 @@
 # Copy jar to the lib/ directory of the PC version project
 add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                           "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
+                           "${SIMULATOR_JAR_PATH}"
                            "${CMAKE_SOURCE_DIR}/src/pc/${PROJECT_NAME}/lib/${PROJECT_NAME}Simulator.jar"
                    COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the PC version project lib/ directory"
                    VERBATIM)
@@ -27,7 +26,7 @@
 # Copy jar to the libs/ directory of the Android version project
 add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                           "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
+                           "${SIMULATOR_JAR_PATH}"
                            "${CMAKE_SOURCE_DIR}/src/android/${PROJECT_NAME}/app/libs/${PROJECT_NAME}Simulator.jar"
                    COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the Android version project libs/ directory"
                    VERBATIM)
@@ -35,7 +34,7 @@
 # Copy jar to DRMIPS_ZIP_BUILD_DIRECTORY
 add_custom_command(TARGET "${PROJECT_NAME}Simulator" POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                           "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Simulator.jar"
+                           "${SIMULATOR_JAR_PATH}"
                            "${DRMIPS_ZIP_BUILD_DIR}/lib/${PROJECT_NAME}Simulator.jar"
                    COMMENT "Copying ${PROJECT_NAME}Simulator.jar to the ZIP build directory"
                    VERBATIM)

=== simulator/DrMIPSSimulator/test/CMakeLists.txt ===
# List of Java source files
file(GLOB_RECURSE SRC RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" brunonova/*.java)

# Jar compilation target
add_jar("${PROJECT_NAME}Tests" ${SRC} INCLUDE_JARS "${PROJECT_NAME}Simulator" "${JUNIT_PATH}")
add_custom_target(tests DEPENDS "${PROJECT_NAME}Tests") # add meta-target "tests"
get_property(TEST_JAR_PATH TARGET "${PROJECT_NAME}Tests" PROPERTY JAR_FILE) # find path to built jar

# Add "test" target to run the unit tests
add_custom_target(test COMMAND "${Java_JAVA_EXECUTABLE}" -cp "${JUNIT_PATH}:${SIMULATOR_JAR_PATH}:${TEST_JAR_PATH}"
                               org.junit.runner.JUnitCore brunonova.drmips.simulator.TestSuite
                       DEPENDS tests
                       COMMENT "Running tests...")

=== debian/changelog ===
drmips (2.0.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixed the build failure with Java 11 (Closes: #912230)

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 12 Sep 2019 10:01:49 +0200

drmips (2.0.1-2) unstable; urgency=low

  * debian/control: Depend on default-jre and Build-Depend on default-jdk,
    instead of on a specific version of openjdk (Closes: #814161).

 -- Bruno Nova <brunomb.nova@gmail.com>  Thu, 11 Feb 2016 12:47:04 +0000

drmips (2.0.1-1) unstable; urgency=low

  * New upstream release.
  * d/control: removed texlive* from Build-Depends.
  * d/copyright: removed license of cmake/Modules/UseLATEX.cmake.
  * d/doc-base: merged the d/doc-base.* files into a single file, and update
    it.
  * d/doc-base.*: files removed.

 -- Bruno Nova <brunomb.nova@gmail.com>  Mon, 30 Nov 2015 21:43:00 +0000

drmips (2.0.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Added junit4 to Build-Depends.
    - Changed java6-jdk to java7-jdk in Build-Depends.
    - Changed java6-runtime to java7-runtime in Depends.
  * debian/menu: file removed as it's now obsolete.
  * debian/rules: update path in override_dh_clean target.

 -- Bruno Nova <brunomb.nova@gmail.com>  Sun, 22 Nov 2015 22:59:21 +0000

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,7 @@
 Section: electronics
 Priority: optional
 Maintainer: Bruno Nova <brunomb.nova@gmail.com>
-Build-Depends: debhelper (>= 9), cmake (>= 2.8), texlive, texlive-latex-extra,
-               texlive-science, texlive-lang-portuguese,
-               openjdk-7-jdk | java6-jdk
+Build-Depends: debhelper (>= 9), cmake (>= 2.8), default-jdk, junit4
 Standards-Version: 3.9.6
 Homepage: http://brunonova.github.io/drmips/
 Vcs-Git: https://github.com/brunonova/drmips -b debian
@@ -12,7 +10,7 @@
 
 Package: drmips
 Architecture: all
-Depends: ${misc:Depends}, openjdk-7-jre | java6-runtime
+Depends: ${misc:Depends}, default-jre
 Description: Educational MIPS simulator
  DrMIPS is a graphical simulator of the MIPS processor to support computer
  architecture teaching and learning. It is intuitive, versatile and

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://github.com/brunonova/drmips/releases /brunonova/drmips/releases/download/v.*/DrMIPS_v(.*)\.tar\.(?:gz|bz2|xz)
